#ifndef __wtw__cwin_h__
#define __wtw__cwin_h__

#include "wtwPlugin.h"
#include "wtwProtocol.h"

struct wtwConferenceWindowCreate {
	int				structSize;
	const wchar_t * windowID;

	WTWFUNCTION		windowCallback;
	DWORD			flags;

	HINSTANCE		hInst; // tego podawac niby nei trzebe, chyba, ze chcemy uzyc destroyall

	const wchar_t * roomMenuID;		// id menu la przycisku "menu"
	const wchar_t * contactMenuID;	// id menu dla kontaktu
};

#define CONFERENCE_FLAG_STATUS_TAB		0x00000001
#define CONFERENCE_FLAG_CONFERENCE_TAB	0x00000002

#define CONFERENCE_FLAG_STANDARD		0x00000003

struct wtwConferenceWindowCallback { // wparam w callbacku
	int				structSize;
	const wchar_t * id;
	DWORD			event;
	WTW_PTR			windowID;
	POINT			pt; // do klikow myszonem
};

#define CONFERENCE_EVENT_SEND_MESSAGE		1 // lparam - wtwMessageDef*
#define CONFERENCE_EVENT_WND_CLOSED			2 // lparam - NULL
#define CONFERENCE_EVENT_CT_LDBLCLK			3 // lparam - 
#define CONFERENCE_EVENT_CT_RCLICK			4 // lparam - 
#define CONFERENCE_EVENT_CT_LCLICK			5 // lparam - 

#define WTW_CONFERENCE_WINDOW_CREATE		L"WTW/Conf/Create"		// zwraca handle nowego okna, wparam - wtwconfwindowcreate*
#define WTW_CONFERENCE_WINDOW_DESTROY		L"WTW/Conf/Destroy"		// wparam - to co zwrocilo create
#define WTW_CONFERENCE_WINDOW_DESTROY_ALL	L"WTW/Conf/DestroyAll"	// wparam - hInstance
#define WTW_CONFERENCE_WINDOW_SET_TITLE		L"WTW/Conf/SetTitle"	// wparam, to co zwrocilo create, lparam - tekst
#define WTW_CONFERENCE_WINDOW_FIND			L"WTW/Conf/Find"		// wparam - const wchar_t * - id, zwraca to co create lub null
#define WTW_CONFERENCE_WINDOW_ADD_PRIV		L"WTW/Conf/AddPriv"		// wparam - to co podalo create, lparam - wtwConferencePriv, zwraca 0, 1 lub 2

#define WTW_CONFERENCE_WINDOW_ADD_CT		L"WTW/Conf/AddCT"		// wparam - to co podalo create, lparam - wtwConferenceContact* - dziala takze jako mod, jesli znajdzie juz kontakt o identycznym id
#define WTW_CONFERENCE_WINDOW_DEL_CT		L"WTW/Conf/DelCT"		// wparam - to co podalo create, lparam - contactID, wchar_t *

struct wtwConferenceContact {
	int				structSize;
	const wchar_t * id;
	const wchar_t * name;
	const wchar_t * hIconID;

	int				sortClass;
};

#define WTW_CONFERENCE_WINDOW_ADD_MESSAGE	L"WTW/Conf/AddMessage"  // dodaje wiadomsoc do okna, wparam - to co podalo create, lparam wtwconferencemessage

struct wtwConferenceMessageDef {
	int				structSize;
	wtwMessageDef   message;

	DWORD			type;
	const wchar_t * nick;
};

#define CONFERENCE_MESSAGE_TYPE_STATUS		0
#define CONFERENCE_MESSAGE_TYPE_MESSAGE		1
#define CONFERENCE_MESSAGE_TYPE_PRIVATE		2

#endif