#ifndef __wtw__ctl_h__
#define __wtw__ctl_h__

#include "wtwPlugin.h"
#include "wtwContact.h"
#include "wtwGraph.h"

#define WTW_CTL_ADD_CONTACT L"WTW/CTL/AddContact"	// logiczne
#define WTW_CTL_FND_CONTACT L"WTW/CTL/FndContact"	// wP - wtwContactDef*, zwraca itemhandle lub NULL
#define WTW_CTL_DEL_CONTACT L"WTW/CTL/DelContact"	// wP - itemHandle
#define WTW_CTL_MOD_CONTACT L"WTW/CTL/ModContact"	// wP - itemhandle, lP - ContactListItem*

#define WTW_CTL_ADD_CONTACT_ICON L"WTW/CTL/AddContactIcon" // wP - itemhandle, lP - wtwIconSetDef*
#define WTW_CTL_DEL_CONTACT_ICON L"WTW/CTL/DelContactIcon"
#define WTW_CTL_MOD_CONTACT_ICON L"WTW/CTL/ModContactIcon"

#define WTW_CTL_ENABLE_DRAWING	L"WTW/CTL/EnableDrawing" // w param 1 - enable, 0 - disable

#define WTW_CTL_SET_CONTACT_STATE	L"WTW/CTL/SetContactState" // zamiast wolac caly czas Mod do ikonki 
															 // mozemy uzyc tego do uaktualnienia stanu
															 // ale wczesniej trzeba wywolac reg_mappng
															 // aby  WTW wiedzial ktory index ikonki 
															 // jest ktory, wparam - presencedef* z ct info,
															 // lparam mzoe byc null, to wtw sam poszuka kontaktu,
															 // w innym wypadku podajemy tam handle do kontaktu

#define WTW_CTL_SET_OVERLAY_STATE_MAP L"WTW/CTL/SetOverlayState" // wP - OVL_, lP = contactHandle

#define WTW_CTL_REGISTER_MAPPING	L"WTW/CTL/RegisterMapping"	// do tlumaczenia indexw ikonek na
																// stany i odwrotnie
																// mapka jest automagicznie
																// rejestrowana dla protkolu
																// jesli ladowalismy caly set,
																// ale jak chcemy mozmy zrobic wlasna

#define WTW_CTL_SET_ALL_OFFLINE		L"WTW/CTL/SetAllOffline"	// przydatne przy rozczeniu ;)
																// wparam = netID, lparam netSID;
#define WTW_CTL_DELETE_ALL			L"WTW/CTL/DeleteAll"		// przydatne przy wylaczeniu pluga
																// wparam = netID, lparam netSID;

struct wtwContactListItem {
	int				structSize;

	wtwContactDef	contactInfo;

	const wchar_t *	itemText;
	const wchar_t *	itemDescription;
	const wchar_t *	itemGroup;

	DWORD			itemType;
	DWORD			itemState;
	void		  * itemHandle;			// przy dodawaniu dostajemy to spowrotem;

	int				flags;
};

#define WTW_CTL_FLAG_REPLACE_DUPLICATE	0x00000001 // przy tej fladze zastapi na liscie dane kontaktu o identycznym id, nid i nsid (poza stanem i opisem)
#define WTW_CTL_FLAG_DO_NOT_EXPAND		0x00000002
#define WTW_CTL_FLAG_UPDATE_STATE		0x00000004

#define	WTW_CTL_TYPE_GROUP		0x00000001	// grupa
#define	WTW_CTL_TYPE_METAC		0x00000002	// metakontant
#define	WTW_CTL_TYPE_ELEMENT	0x00000003	// kontakt
#define	WTW_CTL_TYPE_USER		0x00000004	// niezaimplementowane
#define	WTW_CTL_TYPE_SEPARATOR	0x00000005	// j/w

#define	WTW_CTL_STATE_ONLINE	0x00000001
#define	WTW_CTL_STATE_OFFLINE	0x00000002
#define	WTW_CTL_STATE_OFFLIST	0x00000004
#define	WTW_CTL_STATE_WAITAUTH	0x00000008
#define	WTW_CTL_STATE_BLOCKED	0x00000010
#define	WTW_CTL_STATE_NOAUTH	0x00000020
#define	WTW_CTL_STATE_UNKNOWN	0x00000040
#define	WTW_CTL_STATE_TEXTONLY	0x00000080


///////////////////////////////////////////////////////////////////////////////

struct wtwAvatarSet {
	int				structSize;
	
	const wchar_t * filePath;		// sciezka do pliku, pelna
	int				avatarType;		// typ grafiki
	
	void		  * contactHandle;	// handle kontaktu, jesli null to ustawiamy net iD, SID i ctID w contact info, 
	wtwContactDef * contactInfo;	// jesli cti null, to handle musi byc podany

	DWORD			flags;			// opcje

};

#define WTW_AVATAR_TYPE_PNG	0x0001
#define WTW_AVATAR_TYPE_JPG	0x0002
#define WTW_AVATAR_TYPE_GIF	0x0003
#define WTW_AVATAR_TYPE_BMP	0x0004
#define WTW_AVATAR_TYPE_ICO	0x0005

#define	WTW_AVATAR_SET L"WTW/CTL/SetAvatar"

#define WTW_CTL_ENUM_GROUPS_HWND L"WTW/CTL/EnumGroupsHWND" // wParam - HWND ComboBox'a

#endif