#ifndef __wtw__ft_h__
#define __wtw__ft_h__

#include "wtwPlugin.h"

#define	FT_DIRECTION_INCOMING 1
#define	FT_DIRECTION_OUTGOING 2

#define	WTW_FT_STATE_ACTIVE		0x00000001
#define	WTW_FT_STATE_USER		0x00000002
#define	WTW_FT_STATE_CONNECTING	0x00000004
#define	WTW_FT_STATE_LISTENING	0x00000008
#define	WTW_FT_STATE_PENDING	0x00000010
#define	WTW_FT_STATE_COMPLETED	0x00000020
#define	WTW_FT_STATE_SKIPPED	0x00000020
#define	WTW_FT_STATE_ERROR		0x00000080


struct wtwFTInit {
	int				structSize;
	
	const wchar_t * id;
	const wchar_t * netID;
	int				netSID;

	WTWFUNCTION		iCallback;		// start, stop, addfiles, remove
	WTWFUNCTION		rUpdateState;	// zwracane; wP - handle grupy/pliku lP - wtwFTState*
	
	DWORD			transferState;
	DWORD			direction;
	const wchar_t * statusText;
	const wchar_t * filesDirectory;	// przy odbiorze, potrzebne do otwarcia kliknieciem ;p
};

struct wtwFTAddFile {
	int				structSize;
	
	const wchar_t * fileName;
	
	unsigned long long fileSize;
	
	DWORD			fileState;

	int				groupHandle;
};

struct wtwFTState {
	int				structSize;
	
	const wchar_t * statusText;
	
	unsigned long long iTransferred;

	DWORD			fileState;

};

#define WTW_FT_INIT_TRANSFER	L"WTW/FTInitTransfer"	// zwraca handle do grupy
#define WTW_FT_ADD_FILE			L"WTW/FTAddFile"		// dodaje plik do grupy, wP - groupHandle, lP wtwFTAddFile*, zwraca handle itema
#define WTW_FT_DROP				L"WTW/FTDrop"			// zwalnia callback
#define WTW_FT_PREPARE_WND		L"WTW/FTPrepareWnd"		// przygotowuje i pokazuje okno, wywolac na poczatku

struct wtwFTQuestion {
	int				structSize;
	const wchar_t * statusText;

	wchar_t		  * pBuffer;
	DWORD			iBuffer;

	const wchar_t * from;	// do zastapienia %from%
};

#define WTW_FT_ASK_FOR_CONFIRMATION L"WTW/FTAskForConfirmation"

#endif