#pragma once

#include "wtwPlugin.h"

#define WTW_LOG_LEVEL_CRITICAL	-2
#define WTW_LOG_LEVEL_ERROR		0
#define WTW_LOG_LEVEL_NORMAL	1
#define WTW_LOG_LEVEL_DEBUG		5
#define WTW_LOG_LEVEL_DEBUG_X	6	// tylko widoczne jesli waczony jest "debug messages" i program wystartowa
									// z parametrem --debug

#pragma warning(disable: 4311)

struct wtwLogDef {

	int				structSize;

	int				logLevel; // domyslnie 1

	const wchar_t * pModName; //4 znaki
	const wchar_t * pMessage; //co pokazac

	DWORD			iReserved;

};

#define WTW_LOG_FUNCTION L"WTW/Log"

void __inline __LOG(
					WTWFUNCTIONS *pF, 
					const wchar_t *mdl, 
					const wchar_t *msg, 
					int lvl = WTW_LOG_LEVEL_NORMAL
					)
{

	wtwLogDef p;
	initStruct(p);

	p.logLevel = lvl;
	p.pMessage = msg;
	p.pModName = mdl;

	pF->Call(
		WTW_LOG_FUNCTION, 
		reinterpret_cast<TPARAM>(&p), 
		NULL
		);

}

void __inline __LOG_C(
					WTWFUNCTIONS *pF, 
					const wchar_t *msg
					)
{
	wtwLogDef p;
	initStruct(p);

	p.logLevel = -2;
	p.pMessage = msg;
	p.pModName = NULL;

	pF->Call(
		WTW_LOG_FUNCTION, 
		reinterpret_cast<TPARAM>(&p), 
		NULL
		);
}
