#ifndef __wtw_plugin_options_h__
#define __wtw_plugin_options_h__

#include "wtwPlugin.h"

#define WTW_OPTIONS_GROUP_MAIN		L"WTW/Group/Main"		// to do parentID
#define WTW_OPTIONS_GROUP_INTERFACE L"WTW/Group/Interface"	// to tez
#define WTW_OPTIONS_GROUP_NETWORK	L"WTW/Group/Network"	// to take
#define WTW_OPTIONS_GROUP_PLUGINS	L"WTW/Group/Plugz"		// i to te, ale jak sie poda NULL, to bedzie i tak to

#define WTW_OPTIONS_PAGE_ID_CTL		L"WTW/OPage/CTL"		// opcje listy kontaktw
#define WTW_OPTIONS_PAGE_ID_AVATAR	L"WTW/OPage/Avatar"		// opcje avatarw

typedef struct {

 int			structSize;		// wiadome, ne?

 const wchar_t *iD;				// unikalny ID
 const wchar_t *parentID;		// ID opzycji pod ktr bedzie umieszczona nasza pozycja

 const wchar_t *caption;		// tresc na liscie zakladek w opcjach

 int			flags;			// opcje

 HICON			icon;			// ikonka, and i mean it IKONKA (nie bitmapka) 16x16
 const wchar_t *iconID;			// albo WTW_GRAPH_ID
 
 WTWFUNCTION	callBack;		// callback do funkcji ktora naszeopcje obsluguje

 void		*	ownerData;		// jakies nasze dane

} wtwOptionPageDef;

#define WTW_OPTIONS_PAGE_FLAG_GROUPSEC 0x01000000

typedef struct {

 int				structSize;	// j/w

 wtwOptionPageDef  *page;		// w zasadzie to co przekazalismy do add
 int				action;		// co chce komunikator abysmy zrobili

 HWND				handle;		// to podajemy jako parent naszego okna opcji
 void *				pHandle;	// do uytku wewntrznego

 int				x;			// przy _SHOW, x
 int				y;			
 int				cx;			// szerokosc
 int				cy;			// wysokosc

 COLORREF			bgColor;	// kolor tla okna

 int				flags;		// opcje

 wchar_t			windowCaption[256]; // Nazwa zakadki
 wchar_t			windowDescrip[512]; // Opis danej zakadki
 
 HICON				icon;       // Ikonka pokazywana przed nazw i opisem (32x32)
 const wchar_t *	iconID;		// albo WTW_GRAPH_ID_

} wtwOptionPageShowInfo;

#define WTW_OPTIONS_PAGE_ACTION_SHOW           1 //Pokazac okienko
#define WTW_OPTIONS_PAGE_ACTION_HIDE           2 //Schowac okienko
#define WTW_OPTIONS_PAGE_ACTION_OK             3 //Kliknieto OK
#define WTW_OPTIONS_PAGE_ACTION_APPLY          4 //Kliknieto Zastosuj
#define WTW_OPTIONS_PAGE_ACTION_CANCEL         5 //Kliknieto Anuluj

/////////////////////////////////////////////////////////////////////////////////
//
// WTW_ADD_OPTIONS_PAGE
// 
// wParam - hInstance
// lParam - wtwOptionpadeDef*
// 

#define WTW_ADD_OPTIONS_PAGE                   L"WTW/AddOptionsPage"

/////////////////////////////////////////////////////////////////////////////////
//
// WTW_REMOVE_OPTIONS_PAGES
// 
// wParam - hInstance
// lParam - NULL
// 

#define WTW_REMOVE_OPTIONS_PAGES               L"WTW/RemoveOptionsPages"

/*
#define WTW_OPTIONS_PERFORM_ACTION             "WTW/OptionsPerformAction"

//Pokazuje/chowa okno opcji
#define WTW_OPTIONS_ACTION_SHOW           1
//Zmienia widoczna zakladke
#define WTW_OPTIONS_ACTION_SWITCHPAGE     2
//Symuluje nacisniecie OK
#define WTW_OPTIONS_ACTION_OK             3
//Symuluje nacisniecie Zastosuj
#define WTW_OPTIONS_ACTION_APPLY          4
//Symuluje nacisniecie Anuluj
#define WTW_OPTIONS_ACTION_CANCEL         5
*/

#endif