#ifndef _wtwPlugin_h_
#define _wtwPlugin_h_

#include "wtwCaps.h"

#define WTW_CALL_REASON_AUTO	1	// plug ladowany automagicznie, bo tak
#define WTW_CALL_REASON_MANUAL	2	// reczny start by user
#define WTW_CALL_REASON_AUTOADD 3	// automagicznie, ale jest nowododany
#define WTW_CALL_REASON_EXIT    4	// konczymy prace programu

#ifndef _M_IX86
#define WTW_PTR __int64
#define WTW_PARAM unsigned __int64
#else
#define WTW_PTR int
#define WTW_PARAM unsigned long
#endif

#define TPTR WTW_PTR
#define TPARAM WTW_PARAM

#define QWORD unsigned __int64

//#define MAKE_DWORD_VERSION(a,b,c,d) ((DWORD)a&0xFF)<<24|((DWORD)b&0xFF)<<16|((DWORD)c&0xFF)<<8|((DWORD)d&0xFF)

#define MAKE_QWORD_VERSION(a,b,c,d) ((QWORD)a&0xFFFF)<<48|((QWORD)b&0xFFFF)<<32|((QWORD)c&0xFFFF)<<16|((QWORD)d&0xFFFF)

#define PLUGIN_API_VERSION MAKE_QWORD_VERSION(1,0,0,1100)

#define V_GET_MAJOR(a)		(DWORD)(((QWORD)a&0xFFFF000000000000) >> 48) 
#define V_GET_MINOR(a)		(DWORD)(((QWORD)a&0x0000FFFF00000000) >> 32)
#define V_GET_REVISION(a)	(DWORD)(((QWORD)a&0x00000000FFFF0000) >> 16)
#define V_GET_BUILD(a)		(DWORD)(((QWORD)a&0x000000000000FFFF))

#define initStruct(st) {memset(&st,0,sizeof(st));st.structSize=sizeof(st);};

typedef WTW_PTR (*WTWHOOK)		(WTW_PARAM, WTW_PARAM);
typedef WTW_PTR (*WTWFUNCTION)	(WTW_PARAM, WTW_PARAM);

typedef struct {

	int				structSize;				// to co sobie ustawi initStruct

	const wchar_t * pluginName;				// nazwa wtyczki

	const wchar_t * pluginDescription;		// jakis opis
	const wchar_t * pluginCopyright;		// kto ma prawa autorskie

	const wchar_t * pluginAuthor;			// nazwa autora
	const wchar_t * pluginAuthorEmail;		// mail kontaktowy do autora
	const wchar_t * pluginAuthorHomepage;	// i jego strona domowa

	const wchar_t * pluginUpdateURL;		// URL (http://) do pluku XML opisujacego procedure updateu

    QWORD			pluginAPIVersion;		// wersja PI na ktora zostala napisana wtyczka
	QWORD			pluginVersion;			// wersja wtyczki

	DWORD			pluginClass;			// klasa wtyczki, tylko do grupy to potrzaebne na liscie ;p

	WTWFUNCTION		pluginAboutFunction;	// funkcja wywoywana jak kto klinie "o wtyczce", NULL, NULL

	DWORD			Reserved1;				// moze sie przyda kiedys
	DWORD			Reserved2;
	DWORD			Reserved3;
	DWORD			Reserved4;
	
} WTWPLUGINFO;

struct WTWEVENTS {

	HANDLE (*Create)      (const wchar_t *						);
	WTW_PTR(*Destroy)     (HANDLE								);
	WTW_PTR(*Notify)      (HANDLE,			WTW_PARAM, WTW_PARAM);
	HANDLE (*Hook)        (const wchar_t *,	WTWHOOK				);
	WTW_PTR(*Unhook)      (HANDLE								);

};

typedef struct {

	HANDLE          (*Create)  (const wchar_t *,	WTWFUNCTION			);
	WTW_PTR         (*Destroy) (HANDLE									);
	WTW_PTR         (*Call)    (const wchar_t *,	WTW_PARAM, WTW_PARAM);
	WTW_PTR         (*FunctionExists)  (const wchar_t *					);

	WTWEVENTS		ev;

} WTWFUNCTIONS;

/*

	Maj by __stdcall (!) ;P

	//////////////////////////////////////////////////////////////////////////
	//
	// WTWPLUGINFO * queryPlugInfo(DWORD apiVersion, DWORD masterVersion);
	//
	// Wywoywane aby pobra informacje o wtyczce, 
	// 
	//  apiVersion -	wersja api  programu wywoujcego, 
	//					masterversion - wersja programu
	//

	///////////////////////////////////////////////////////////////////////////	
	//
	// int pluginLoad(DWORD callReason, WTWFUNCTIONS *fC);
	//
	// Wywoane przy dowaniu wtyczki, 
	//
	//  callReason -	przyzyna wywoania funkcji tj czy ladowanie 
	//					automatyczne, czy zuytkownik recznie odpala wtyczke, etc
	//
	//	fC -			wksnik do funkcji interface'u programu
	//  

	///////////////////////////////////////////////////////////////////////////
	//
	// int pluginUnload(DWORD callReason)
	//
	// Wywoywane przy wydowaniu wtyczki
	//
	//  callReason -	podobnie jak w pluginLoad
	//

*/


#endif
