﻿#define _CRT_SECURE_NO_WARNINGS

#include <windows.h>
#include "API/plInterface.h"
#include <string>
#include <fstream>
#include "main.h"
#include "bass.h"

using namespace std;

WTWFUNCTIONS *wtw;
HANDLE ProtoHook;

class Sounds {
public:
	Sounds() {
	    wchar_t temp[MAX_PATH];
		GetModuleFileName(NULL, temp, MAX_PATH - 1);
		path = temp;
		path.resize(path.find_last_of(L"\\"));
		path += L"\\Sounds\\";
	};

	~Sounds() {
		BASS_Stop();
		BASS_Free();
	};

	bool init() {
   		if (HIWORD(BASS_GetVersion()) != BASSVERSION) {
			MessageBox(NULL,L"Załadowana została nieprawidłowa wersja biblioteki bass.dll. Wtyczka Dźwięki wymaga wersji 2.4.", L"Dźwięki - błąd!", MB_ICONERROR);
			return false;
		}

		if(BASS_Init(1, 44100, 0, NULL, NULL)) {
			BASS_Start();
			return true;
		}
		return false;
	}

	void dispatch(wtwSoundEvent* event) {
		wstring Wav;
		switch(event->event) {
			case WSE_CONTACT_APPEARED: {
				Wav = soundPath(event, SOUND_CONTACT_APPEARED);
				break;
			}

			case WSE_CONTACT_STATUS: {
				Wav = soundPath(event, SOUND_CONTACT_STATUS);
				break;
			}

			case WSE_CONTACT_TRAY_NOTIFY: {
				Wav = soundPath(event, SOUND_CONTACT_TRAY_NOTIFY);
				break;
			}

			case WSE_NETWORK_LOGON: {
				Wav = soundPath(event, SOUND_NETWORK_LOGON);
				break;
			}

			case WSE_NETWORK_LOGOFF: {
				Wav = soundPath(event, SOUND_NETWORK_LOGOFF);
				break;
			}

			case WSE_CHATWND_OPEN_AUTO: {
				Wav = soundPath(event, SOUND_CHATWND_OPEN_AUTO);
				break;
			}

			case WSE_CHATWND_OPEN_MANUAL: {
				Wav = soundPath(event, SOUND_CHATWND_OPEN_MANUAL);
				break;
			}

			case WSE_CHATWND_NEW_MESSAGE: {
				Wav = soundPath(event, SOUND_CHATWND_NEW_MESSAGE);
				break;
			}

			case WSE_CHATWND_NEW_INFO: {
				Wav = soundPath(event, SOUND_CHATWND_NEW_INFO);
				break;
			}

			case WSE_CHATWND_NEW_ERROR: {
				Wav = soundPath(event, SOUND_CHATWND_NEW_ERROR);
				break;
			}

			case WSE_CHATWND_NEW_WARNING: {
				Wav = soundPath(event, SOUND_CHATWND_NEW_WARNING);
				break;
			}

			case WSE_AUTHWND_POPUP: {
				Wav = soundPath(event, SOUND_AUTHWND_POPUP);
				break;
			}

			case WSE_RECV_FILE: {
				Wav = soundPath(event, SOUND_RECV_FILE);
				break;
			}

			case WSE_NEW_EMAIL: {
				Wav = soundPath(event, SOUND_NEW_EMAIL);
				break;
			}

			case WSE_MESSAGEWND_POPUP: {
				Wav = soundPath(event, SOUND_MESSAGEWND_POPUP);
				break;
			}
			default: break;
		}
		if(!Wav.empty())
			play(Wav);

	}

private:
	bool fileExists(const wstring& path) const {
		wstring path2 = path;
		HANDLE hFile = CreateFile(path2.c_str(), GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE, NULL, OPEN_EXISTING,0,NULL);
		if(hFile == INVALID_HANDLE_VALUE)
			return false;

		CloseHandle(hFile);
		return true;
	}

	wstring soundPath(wtwSoundEvent* event, const wstring& Sound) const {
		wstring path;
		if (event->pContact) {
			//indywidualny dla kontaktu
			path = this->path;
			path += event->pContact->netID;
			path += L"\\";
			path += event->pContact->id;
			path += Sound;

			if(fileExists(path)) {
				return path;
			} else {
				//dźwięk dla sieci
				path = this->path;
				path += event->pContact->netID;
				path += Sound;

				if(fileExists(path)) {
					return path;
				}
			}
		}

		path = this->path + L"WTW" + Sound;

		if(fileExists(path))
		   return path;

		path.clear();
		return path;
	}

	void play(const wstring& file) {
		HSTREAM stream = BASS_StreamCreateFile(FALSE, file.c_str(), 0, 0, BASS_STREAM_AUTOFREE | BASS_UNICODE);
		BASS_ChannelPlay(stream, false);
	}

	wstring path;
};

Sounds* sm = NULL;

WTWPLUGINFO plugInfo = {
	sizeof(WTWPLUGINFO),
	L"Dzwieki",
	L"Wtyczka do obsługi dźwięków",
	L"© 2009 Marcin Lewicz (Dziaddu)",
	L"Marcin Lewicz (Dziaddu) (poprawki: adrian_007)",
	L"dziaddu2@tlen.pl",
	L"dziaddu.eportal.com.pl",
	L"",
	PLUGIN_API_VERSION,
	MAKE_QWORD_VERSION(0, 2, 1, 1),
	WTW_CLASS_UTILITY,
	NULL,
	0,
	0,
	0,
	0
};

extern "C" __declspec(dllexport) WTWPLUGINFO * _stdcall queryPlugInfo(DWORD apiVersion, DWORD masterVersion);
extern "C" __declspec(dllexport) int _stdcall pluginLoad(DWORD callReason, WTWFUNCTIONS *fC);
extern "C" __declspec(dllexport) int _stdcall pluginUnload(DWORD callReason);


WTW_PTR SoundEvent(WTW_PARAM wP, WTW_PARAM) {
	sm->dispatch(reinterpret_cast<wtwSoundEvent*>(wP));
    return 0;
}

__declspec(dllexport) WTWPLUGINFO * _stdcall queryPlugInfo(DWORD apiVersion, DWORD masterVersion) {
    return &plugInfo;
}

__declspec(dllexport) int _stdcall pluginLoad(DWORD callReason, WTWFUNCTIONS *fC) {
    wtw = fC;
	sm = new Sounds;
	if(!sm->init()) {
		//...
	} else {
		ProtoHook = wtw->ev.Hook(WTW_EVENT_ON_SOUND, SoundEvent);
	}
    return 0;
}

__declspec(dllexport) int _stdcall pluginUnload(DWORD callReason) {
	if(sm) delete sm;
    return 0;
}
